package com.social 
{
	/**
	 * Wrapper for Facebook API
	 * @author Six
	 */

	import com.facebook.graph.FacebookDesktop;
	import com.facebook.graph.controls.Distractor;
	import com.facebook.graph.net.FacebookRequest;
	import com.streamparty.events.SocialEvent;
	
	import flash.display.BitmapData;
	import flash.events.EventDispatcher;
	
	import mx.collections.ArrayCollection;

	public class FacebookAPI extends EventDispatcher implements SocialInterface
	{
		[Bindable]
		public var isConnected:Boolean = false;

		// Ctor
		public function FacebookAPI() 
		{
		}

		/**
		 * Methods
		 */
		
		 // Connect to Facebook
		public function init():void
		{
			
		}

		// Logout from Facebook
		public function login(str:String = ""):void
		{
			// Stream Party API key
			FacebookDesktop.init('143721159011380', handleLogin);
			FacebookDesktop.login(handleLogin, []);
		}

		// Upload files
		public function upload(images:Array, filenames:ArrayCollection, bitmapDatas:ArrayCollection):void
		{
			for (var i:int = 0; i < images.length; ++i)
			{
				var str:String = images[i] as String;
				var index:int = filenames.getItemIndex(str);

				var bd:BitmapData = bitmapDatas.getItemAt(index) as BitmapData;

				// Empty upload description
				var values:Object = {message:'', fileName:'', image: bd};
				FacebookDesktop.api('/me/photos', handleUploadComplete, values,'POST');
			}
		}
		
		// Logout from Facebook
		public function logout():void
		{
			isConnected = false;
			FacebookDesktop.logout();
		}

		/**
		 * Handlers
		 */
		private function handleLogin(response:Object, fail:Object):void
		{
			if (response)
			{
				isConnected = true;
				dispatchEvent(new SocialEvent(SocialEvent.FACEBOOK_LOGIN_SUCCESS));
			}	
		}

		private function handleLogout(response:Object, fail:Object):void
		{
			if (response)
				isConnected = false;
		}

		private function handleUploadComplete(response:Object, fail:Object):void
		{
		}
	}

}
