package com.social 
{
	/**
	 * Wrapper for Twitter API
	 * @author Six
	 */
	
	import com.adobe.net.URI;
	import com.adobe.serialization.json.JSON;
	import com.coderanger.OAuthEvent;
	import com.coderanger.OAuthManager;
	import com.coderanger.Parameter;
	import com.coderanger.QueryString;
	
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	
	import mx.containers.TitleWindow;
	import mx.controls.Alert;
	import mx.controls.TextArea;
	import mx.events.CloseEvent;
	import mx.managers.PopUpManager;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.http.HTTPService;
	
	import spark.components.Button;

	public class TwitterAPI implements SocialInterface
	{
		/**
		 * Fields
		 */
		static private const KEY:String		=	'vLMqtDRyO59bacv7vnX8CA';
		static private const SECRET:String	=	'TkX6I1iSx8Q81yzOJPxnRiSKoM5G55RvjwzQuBYUY';
		
		[Bindable]
		public var isConnected:Boolean = false;
		 
		private var _twitauth:OAuthManager			=	new OAuthManager();
		private var _accessPin:Number				=	0;
		private var _accessToken:String				=	"";
		private var _accessTokenSecret:String		=	"";
		private var _loadingFromSettings:Boolean 	= false;
		
		private var _windowPIN:TitleWindow;
		private var _stage:DisplayObject;
		
		[Bindable]
		private var _enterPinText:TextArea = new TextArea;

		// Ctor
		public function TwitterAPI() 
		{
		}
		
		/**
		 * Methods
		 */

		// Twitter init
		public function init():void
		{
			var settingsFile:File = File.applicationStorageDirectory.resolvePath("StreamPartyTwitterSettings.xml");
			if (settingsFile.exists)
			{
				var fsSettings:FileStream = new FileStream();
				fsSettings.open(settingsFile, FileMode.READ);

				var xmlSettings:XML = new XML(fsSettings.readUTFBytes(fsSettings.bytesAvailable));
				fsSettings.close();

				_accessPin = xmlSettings.accesspin;
				_accessToken = xmlSettings.accesstoken;
				_accessTokenSecret = xmlSettings.accesstokensecret;
			}

			if (_accessPin > 0 && _accessToken.length && _accessTokenSecret.length)
			{
				_loadingFromSettings = true;
			}

			_twitauth.addEventListener(OAuthEvent.ON_REQUEST_TOKEN_RECEIVED, onRequestTokenReceived);
			_twitauth.addEventListener(OAuthEvent.ON_REQUEST_TOKEN_FAILED, onRequestTokenFailed);
			_twitauth.addEventListener(OAuthEvent.ON_ACCESS_TOKEN_RECEIVED, onAccessTokenReceived);
			_twitauth.addEventListener(OAuthEvent.ON_ACCESS_TOKEN_FAILED, onAccessTokenFailed);
			_twitauth.usePinWorkflow = true;
		}

		// PIN
		public function PINLogin(dobj:DisplayObject):void
		{
			_stage = dobj;
			
			if (_loadingFromSettings)
			{
				isConnected = true;
				Alert.show("Vous êtes connecté à Twitter !", "Succès");
				return;
			}
			
			_twitauth.consumerKey = KEY;
			_twitauth.consumerSecret = SECRET;
			_twitauth.oauthDomain = "twitter.com";
			_twitauth.requestToken();
		}

		// Little popup to enter PIN code
		private function showPINWindow():void
		{
			_windowPIN = TitleWindow(PopUpManager.createPopUp(_stage, TitleWindow));

			var pinText:TextArea = new TextArea();
			pinText.text = "PIN :";
			pinText.editable = false;

			_enterPinText.text = "";
			_enterPinText.editable = true;
			_enterPinText.width = 200;
			
			var OKButton:Button = new Button();
			OKButton.label = "Valider";

			_windowPIN.addChild(pinText);
			_windowPIN.addChild(_enterPinText);
			_windowPIN.addChild(OKButton);

			_windowPIN.showCloseButton = true;
			OKButton.addEventListener(MouseEvent.CLICK, validatePIN);
			_windowPIN.addEventListener(CloseEvent.CLOSE, closeHandler);

			PopUpManager.centerPopUp(_windowPIN);
		}

		private function validatePIN(event:Event):void
		{
			this.login(_enterPinText.text);
		}
		
		private function closeHandler(event:CloseEvent):void
		{
			PopUpManager.removePopUp(_windowPIN);
		}
		
		// Twitter login
		public function login(str:String = ""):void
		{
			if (str.length != 7)
			{
				Alert.show("Désolé mais votre code PIN est faux, il doit comporter 7 chiffres.", "Faire confiance à l'application", Alert.OK);
				return;
			}

			if (!_twitauth.validatePin(str))
			{
				Alert.show("Désolé mais votre code PIN est faux, veuillez réessayer.", "Faire confiance à l'application", Alert.OK);
				return;
			}

			_twitauth.requestAccessToken(Number(str));
		}
		
		private function onAccessTokenReceived(event:OAuthEvent):void
		{
			// Save
			_accessPin = _twitauth.accessPin;
			_accessToken = _twitauth.accessToken;
			_accessTokenSecret = _twitauth.accessTokenSecret;

			var xmlSettings:XML = <settings></settings>;
			xmlSettings.accesspin = _accessPin;
			xmlSettings.accesstoken = _accessToken;
			xmlSettings.accesstokensecret = _accessTokenSecret;

			var settingsFile:File = File.applicationStorageDirectory.resolvePath("StreamPartyTwitterSettings.xml");
			var settingsXMLStr:String = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" + xmlSettings.toXMLString();
			var fsSettings:FileStream = new FileStream();
			fsSettings.open(settingsFile, FileMode.WRITE);
			fsSettings.writeUTFBytes(settingsXMLStr);
			fsSettings.close();

			isConnected = true;
			Alert.show("Bravo, vous pouvez twitter maintenant !", "Succès");
		}

		// Twitter TWEETs !!
		public function send(message:String):void
		{
			var url:String = "http://twitter.com/statuses/update.xml";

			var twitauth:OAuthManager = new OAuthManager();
			twitauth.usePinWorkflow = true;
			twitauth.accessPin = _accessPin;
			twitauth.accessToken = _accessToken;
			twitauth.accessTokenSecret = _accessTokenSecret;
			twitauth.consumerKey = KEY;
			twitauth.consumerSecret = SECRET;
			twitauth.oauthDomain = "twitter.com";
			var postData:String = twitauth.getSignedURI("POST", url, "status=" + encodeURIComponent(message));


			var httpService:HTTPService = new HTTPService;
			httpService.url = url;
			httpService.useProxy = false;
			httpService.method = "POST";
			httpService.contentType = "application/x-www-form-urlencoded";
			httpService.addEventListener("result", httpPostResult);
			httpService.addEventListener("fault", httpPostFault);

			var postParams:Object = new QueryString(postData).toPostObject();
			httpService.send(postParams);
		}

		private function httpPostResult(event:ResultEvent):void
		{
			Alert.show("Succès, tweet posté !", "Succès" );
		}

		private function httpPostFault(event:FaultEvent):void
		{
			Alert.show("ERREUR. Tweet non posté à cause de : " + event.statusCode + " - " + event.fault.faultString, "Erreur");
		}

		// Disconnect from Twitter
		public function logout():void
		{
			isConnected = false;
		}

		/**
		 * Handlers
		 */

		private function onRequestTokenReceived(event:OAuthEvent):void
		{
			Alert.show("Autorisez-vous cette application à accéder à vos détails personnels ?\n\nVous serez redirigé vers une page web pour accepter/refuser.",
					   "Faire confiance à l'application", Alert.YES | Alert.NO, null, onRequestTokenAlert, null, Alert.YES );
		}

		private function onRequestTokenFailed(event:OAuthEvent):void
		{
			Alert.show("Désolé un problème vient de survenir...\n\n" + event.data, "Faire confiance à l'application", Alert.OK );
		}
		
		private function onRequestTokenAlert(event:CloseEvent):void
		{
			if (event.detail == Alert.YES)
			{
				_twitauth.requestAuthorisation();
				showPINWindow();
			}
			else
				_twitauth.reset();
		}

		private function onAccessTokenFailed(event:OAuthEvent ):void
		{
			Alert.show( "Désolé un problème est survenu : votre compte est inaccessible\n\n" + event.data, "Faire confiance à l'application", Alert.OK );
		}
	}

}
