package com.streamparty
{
	import flash.display.BitmapData;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.media.Camera;
	import flash.utils.ByteArray;
	
	import mx.collections.ArrayCollection;
	import mx.controls.VideoDisplay;
	import mx.graphics.ImageSnapshot;
	import mx.graphics.codec.PNGEncoder;
	
	public class CameraManager
	{
		private static var _instance : CameraManager;
		private var _camera:Camera;
		private var _isCameraOn:Boolean = false;
		private var _videoDisplay : VideoDisplay;
		
		
		public function CameraManager (b : CameraManagerBlocker) 
		{
			if (b == null)
				throw new Error("Singleton instantiation not permitted!");
		}
		
		public static function get instance() : CameraManager
		{
			if (_instance == null)
				_instance = new CameraManager(new CameraManagerBlocker());
			
			return _instance; 
		}

		public function startCamera(videoDisplay : VideoDisplay):void
		{
			_camera = Camera.getCamera();
			
			if (_camera != null)
			{
				_videoDisplay = videoDisplay;
				_isCameraOn = true;
				_videoDisplay.attachCamera(_camera);
			}
		}
		
		public function stopCamera():void
		{
			if (_isCameraOn)
			{
				_isCameraOn = false;
				_videoDisplay.attachCamera(null);
			}
		}
		
		private var bd:BitmapData;
		public function takeSnapshot(_imagesFilename : ArrayCollection,
									 _imagesBitmapdata:ArrayCollection):void
		{
			if (_isCameraOn)
			{
				//var bd:BitmapData = ImageSnapshot.captureBitmapData(videoDisplay);
				bd = ImageSnapshot.captureBitmapData(_videoDisplay);
				
				// Commented by Sourigna
				//image.source = bd;
				
				// Add image to list
				var pngenc:PNGEncoder = new PNGEncoder();
				var ba:ByteArray = pngenc.encode(bd);
				
				// Create storage directory
				var date:Date = new Date();
				
				var day:int = date.getDate();
				var month:int = date.getMonth() + 1;
				var year:int = date.getFullYear();
				var currentDate:String = day.toString() + "-" + month.toString() + "-" + year.toString();
				
				var directory:String = "StreamParty/" + currentDate + "/";
				var target:File = File.documentsDirectory.resolvePath(directory);
				target.createDirectory();
				
				// Save image in PNG format
				var fileext:String = directory + "image_" + date.getHours().toString() + date.getMinutes().toString() +
					date.getSeconds().toString() + date.getMilliseconds().toString() + ".png";
				var file:File = File.documentsDirectory.resolvePath(fileext);
				
				var fs:FileStream = new FileStream();
				try
				{
					fs.open(file, FileMode.WRITE);
					fs.writeBytes(ba);
					fs.close();
				}
				catch (e:Error)
				{
					trace(e.message);
				}
				
				_imagesFilename.addItem(file.nativePath);
				
				_imagesBitmapdata.addItem(bd);
			}
		}
		
	}
}

internal class CameraManagerBlocker
{
}