package com.streamparty
{
	import com.social.FacebookAPI;
	import com.social.TwitterAPI;
	import com.streamparty.events.SocialEvent;
	
	import flash.display.DisplayObject;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.MouseEvent;
	
	import mx.collections.ArrayCollection;
	import mx.containers.TitleWindow;
	import mx.events.CloseEvent;
	import mx.managers.PopUpManager;
	
	import spark.components.Button;
	import spark.components.TextArea;

	public class SocialManager extends EventDispatcher
	{
		private static var _instance : SocialManager;
		public var _facebook:FacebookAPI = new FacebookAPI();
		public var _twitter:TwitterAPI = new TwitterAPI();

		private var _tweet:TextArea = new TextArea();
		private var _windowTweet:TitleWindow;
		
		public function SocialManager (b : SocialManagerBlocker) 
		{
			if (b == null)
				throw new Error("Singleton instantiation not permitted!");
			
			_facebook.init();
			_twitter.init();
			
			_facebook.addEventListener(SocialEvent.FACEBOOK_LOGIN_SUCCESS, fbLoggedIn);
			_twitter.addEventListener(SocialEvent.TWITTER_LOGIN_SUCCESS, twitterLoggedIn);
		}
		
		public static function get instance() : SocialManager
		{
			if (_instance == null)
				_instance = new SocialManager(new SocialManagerBlocker());
			
			return _instance; 
		}
		
		// Facebook
		
		public function facebookLogin():Boolean
		{
			_facebook.login();
			
			return true; // FIXME
		}
		
		public function facebookUpload(selectedItems : *, 
									   imagesFilename : ArrayCollection,
									   imagesBitmapData : ArrayCollection):void
		{
			_facebook.upload(selectedItems, imagesFilename, imagesBitmapData);
		}
		
		public function facebookLogout():void
		{
			_facebook.logout();
		}

		// Twitter
		
		public function twitterLogin(obj : DisplayObject):void
		{
			_twitter.PINLogin(obj);
		}
		
		// Little popup to enter tweet !
		public function showTweetWindow(obj : DisplayObject):void
		{
			_windowTweet = TitleWindow(PopUpManager.createPopUp(obj, TitleWindow));
			
			var pinText:TextArea = new TextArea();
			pinText.text = "Tweet :";
			pinText.editable = false;
			
			_tweet.text = "";
			_tweet.editable = true;
			_tweet.width = 200;
			
			var OKButton:Button = new Button();
			OKButton.label = "Valider";
			
			_windowTweet.addChild(pinText);
			_windowTweet.addChild(_tweet);
			_windowTweet.addChild(OKButton);
			
			_windowTweet.showCloseButton = true;
			OKButton.addEventListener(MouseEvent.CLICK, validateTweet);
			_windowTweet.addEventListener(CloseEvent.CLOSE, closeHandler);
			
			PopUpManager.centerPopUp(_windowTweet);
		}
		
		private function validateTweet(event:Event):void
		{
			_twitter.send(_tweet.text);
		}
		
		private function closeHandler(event:CloseEvent):void
		{
			PopUpManager.removePopUp(_windowTweet);
		}
		
		public function twitterSend(obj : DisplayObject):void
		{
			showTweetWindow(obj);
		}
		
		public function twitterLogout():void
		{
			_twitter.logout();
		}
		
		// Events
		
		private function fbLoggedIn(e : Event) : void
		{
			dispatchEvent(new SocialEvent(SocialEvent.FACEBOOK_LOGIN_SUCCESS));
		}
		
		private function twitterLoggedIn(e : Event) : void
		{
			dispatchEvent(new SocialEvent(SocialEvent.TWITTER_LOGIN_SUCCESS));
		}
	}
}

internal class SocialManagerBlocker
{
}